## dukto 6.0

=== debian/changelog ===
dukto (6.0-1mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Bump debhelper compat to 9.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 02 Dec 2017 17:30:53 -0800

dukto (6.0-1mx150+1) mx; urgency=medium

  * Repackaged for MX 15.

 -- Mike Purtell <mandbx@sbcglobal.net>  Sat, 25 Jul 2015 20:22:34 -0700

dukto (6.0-1mcr120+1) mepis; urgency=low

  * New release, rebuild for MEPIS 12.0.
  * debian/rules: compress deb packages with xz.
  * Add missing debian/copyright file.
  * Trim down build-depends to what actually is needed.
  * Switch to 3.0 (quilt) source format.
  * Add debian/install file and modify rules file to install binary into /usr/bin.
  * Patch dukto.desktop so it appears under Utilities in the menu.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sun, 11 Jan 2015 18:43:51 -0800

dukto (5.0-2~3~precise1) precise; urgency=low

  * Auto build.

 -- Launchpad Package Builder <noreply@launchpad.net>  Fri, 28 Jun 2013 20:33:26 +0000

dukto (5.0) stable; urgency=low

  * Initial Release (Beta)

 -- Emanuele Colombo <dukto@msec.it>  Mon, 24 Oct 2011 21:50:38 +0200
