=== debian/control ===
Source: dukto
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
Build-Depends: debhelper (>= 9), libqt4-dev (>= 4.7.2)
Homepage: http://www.msec.it/dukto/

Package: dukto
Architecture: any
Depends: ${shlibs:Depends}
Description: Easy multi-platform file and text transfer tool
 Dukto is an easy file transfer tool designed for LAN use.
 You can use it to transfer files from one PC to another,
 without worrying about users, permissions, operating systems,
 protocols, clients, servers and so on... Just start Dukto on
 the two PCs and transfer files and folders by dragging onto
 its window.
