=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt4

%:
	dh $@ --parallel

override_dh_auto_install:
