## dukto 6.0.0%2Bgit20210713

=== debian/changelog ===
dukto (6.0.0+git20210713-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 20 Aug 2023 20:00:11 -0700

dukto (6.0.0+git20210713-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 14 Jul 2021 15:00:36 -0700

dukto (6.0.0+git20210713-1~18.04~ppa1) bionic; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 13 Jul 2021 19:23:24 +0800

dukto (6.0.0+git20210707-1~18.04~ppa1) bionic; urgency=medium

  * New upstream snapshot
  * Remove runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 07 Jul 2021 20:12:24 +0800

dukto (6.0.0+git20210701-1~18.04~ppa2) bionic; urgency=medium

  * Fix missing runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 02 Jul 2021 19:14:54 +0800

dukto (6.0.0+git20210701-1~18.04~ppa1) bionic; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Thu, 01 Jul 2021 20:18:56 +0800

dukto (6.0.0+git20210628-1~18.04~ppa1) bionic; urgency=medium

  * Change upstream to https://github.com/xuzhen/dukto-qt5
    - Support lower version of Qt 5
    - Use CMake for building

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 29 Jun 2021 19:18:39 +0800

dukto (6.0.0-1~18.04~ppa2) bionic; urgency=medium

  * Fixed desktop file

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 21:16:29 +0800

dukto (6.0.0-1~18.04~ppa1) bionic; urgency=medium

  * Initial Release

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 20:53:29 +0800
