=== debian/control ===
Source: dukto
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Xu Zhen <xuzhen@fastmail.com>
Standards-Version: 4.4.0
Homepage: https://github.com/xuzhen/dukto-qt5
Build-Depends: cmake (>= 3.1.0),
               debhelper (>= 11),
               libnotify-dev,
               qtbase5-dev (>= 5.3.0),
               qtdeclarative5-dev

Package: dukto
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: easy file transfer tool for LAN
 Dukto is an easy file transfer tool designed for LAN use. Transfer
 files from one PC (or other device) to another, without worrying
 about users, permissions, operating systems, protocols, clients,
 servers and so on… Just start Dukto on the two PCs and transfer
 files and folders by dragging onto its window. That's all.
 .
 This is a fork of Dukto that can use Qt5.
