=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT = 5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SINGLE_APP=ON -DUSE_NOTIFY_LIBNOTIFY=ON

override_dh_strip:
	dh_strip --no-automatic-dbgsym
