## dukto 6.0.0+git20210713

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,6 @@
  files from one PC (or other device) to another, without worrying
  about users, permissions, operating systems, protocols, clients,
  servers and so on… Just start Dukto on the two PCs and transfer
- files and folders by dragging onto its window. That's all.
+ files and folders by dragging onto it's window. That's all.
  .
  This is a fork of Dukto that can use Qt5.
