=== debian/changelog ===
dukto (6.2.0-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 21 Jun 2025 14:00:42 -0700

dukto (6.2.0-1~22.04~ppa1) jammy; urgency=medium

  * New release

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 20 Apr 2024 00:17:11 +0800

dukto (6.1.1-1~23.10~ppa1) mantic; urgency=medium

  * New release

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 16 Oct 2023 20:25:57 +0800

dukto (6.1.0+git20231014-1~23.10~ppa1) mantic; urgency=medium

  * New release

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 14 Oct 2023 00:12:01 +0800

dukto (6.0.0+git20220321-1~23.04~ppa1) lunar; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 21 Mar 2022 18:59:38 +0800

dukto (6.0.0+git20220316-1~22.04~ppa1) jammy; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 16 Mar 2022 18:49:50 +0800

dukto (6.0.0+git20210919-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 19 Sep 2021 20:10:37 +0800

dukto (6.0.0+git20210902-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 04 Sep 2021 13:01:29 +0800

dukto (6.0.0+git20210717-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 18 Jul 2021 10:18:43 +0800

dukto (6.0.0+git20210716-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 16 Jul 2021 21:21:38 +0800

dukto (6.0.0+git20210713-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 13 Jul 2021 19:23:24 +0800

dukto (6.0.0+git20210707-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot
  * Remove runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 07 Jul 2021 20:12:24 +0800

dukto (6.0.0+git20210701-1~21.10~ppa2) impish; urgency=medium

  * Fix missing runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 02 Jul 2021 19:14:54 +0800

dukto (6.0.0+git20210701-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Thu, 01 Jul 2021 20:18:56 +0800

dukto (6.0.0+git20210628-1~21.10~ppa1) impish; urgency=medium

  * Change upstream to https://github.com/xuzhen/dukto-qt5
    - Support lower version of Qt 5
    - Use CMake for building

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 29 Jun 2021 19:18:39 +0800

dukto (6.0.0-1~21.10~ppa2) impish; urgency=medium

  * Fixed desktop file

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 21:16:29 +0800

dukto (6.0.0-1~21.10~ppa1) impish; urgency=medium

  * Initial Release

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 20:53:29 +0800
